/*
 * Fasterfox is copyright 2005 by Tony Gentilcore. 
 *
 * If you wish to modify, distribute, or reproduce all
 * or part if this extension, please write me first.
 * 
 * No portion of this extension or the code contained 
 * herein this archive may be reproduced without the 
 * express written consent of the author.
 * 
 */
 
// local references to XPCOM services
var PrefetchService = Components.classes["@mozilla.org/prefetch-service;1"].getService(Components.interfaces.nsIPrefetchService);
var PreferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

// Setup the extension core
function FF_init() {	
	
	// because of the nature of overlays and the panel selection code,
	// this is reproduced from chrome://browser/content/pref/pref.xul, and
	// refocuses the prefsCategories window in order to ensure a clean and
	// correct selection of the right panel
	var prefsCategories = document.getElementById("prefsCategories");
	if (prefsCategories) {
 		var lastPanel = 0, button;
		try {
 			lastPanel = PreferencesService.getIntPref("browser.preferences.lastpanel");
		} 
		catch (e) {}

		prefsCategories.focus();
		button = prefsCategories.childNodes[lastPanel];
		if (button) {
			document.getElementById("panelFrame").setAttribute("src", button.getAttribute("url"));
			button.checked = true;
		}
	}

	// Show or hide advanced tabs for Prefs V
	try {
 		if (PreferencesService.getIntPref("extensions.fasterfox.preset", 3)==4) {
			FF_displayTabs(true);
		} else {
			FF_displayTabs(false);
		}
	} catch (e) {}
	
  	return true;
}

// GetAbsoluteURL
function getAbsoluteUrl(url, docUrl) { 
	if(url && url.indexOf('://')>0) return url;
	docUrl=(docUrl)? docUrl.substring(0,docUrl.lastIndexOf('/')+1):dynapi.documentPath;
	url=url.replace(/^(.\/)*/,'');
	docUrl=docUrl.replace(/(\?.*)$/,'').replace(/(#.*)*$/,'').replace(/[^\/]*$/,'');
	if (url.indexOf('/')==0) return docUrl.substring(0,docUrl.indexOf('/',docUrl.indexOf('//')+2))+url;
	else while(url.indexOf('../')==0){
		url=url.replace(/^..\//,'');
		docUrl=docUrl.replace(/([^\/]+[\/][^\/]*)$/,'');
	};
	return docUrl+url;
}

function makeURI(aURL) {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    return ioService.newURI(aURL, null, null);
}

function doEnhancedPrefetch(aEvent) {
	
	// exit if enhanced prefetching is turned off
	if(!PreferencesService.getBoolPref("extensions.fasterfox.enhancedPrefetching")) {
		return;
	}
	
	// doc is document that triggered "onload" event
	var doc = aEvent.originalTarget; 

	// find all links
	var a = doc.getElementsByTagName('a');
	var href, hreflength;

	// iterate through the links
	for (i=0; i<a.length; i++) {
		href = a[i].getAttribute('href');

		// Don't prefetch secure links or links w/ query strings
		if(href.indexOf('?')>0 || href.indexOf('https://')>0) continue;
		
		// Don't prefetch the same page we are on
		if(href == doc.location.href) continue;
		
		// Don't prefetch things that look like a logout link - Special thanks to b1naryb0y for this bug fix
		if(href.indexOf('logout')>0 || href.indexOf('logoff')>0) continue;
		
		// Only prefetch static content, this causes dynamic pages to be ignored
		fileExtensionStartPos = href.length-4;
		if(!(href.indexOf('.htm') == fileExtensionStartPos 
		  || href.indexOf('.html') == fileExtensionStartPos-1
		  || href.indexOf('.txt') == fileExtensionStartPos
		  || href.indexOf('.pdf') == fileExtensionStartPos
		  || href.indexOf('.gif') == fileExtensionStartPos
		  || href.indexOf('.jpg') == fileExtensionStartPos
		  || href.indexOf('.png') == fileExtensionStartPos)) continue;

		try {
			PrefetchService.prefetchURI(makeURI(getAbsoluteUrl(href, doc.location.href)), makeURI(doc.location.href), true);
   		} catch(e) { 
			//if(e.name != "NS_ERROR_ABORT") alert(getAbsoluteUrl(href, doc.location.href) + '\n' + e.toString()); 
		}
	}

}
